/*===========================================================================
 *  Filename : functable-r5rs-number.c
 *  About    : Built-in function table
 *             This file is auto-generated by build_func_table.rb
 *
 *  Copyright (C) 2005-2006 Kazuki Ohta <mover AT hct.zaq.ne.jp>
 *  Copyright (c) 2007-2008 SigScheme Project <uim-en AT googlegroups.com>
 *
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of authors nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
===========================================================================*/

#include <stddef.h>

#include "sigscheme.h"


static const struct scm_func_registration_info scm_functable_r5rs_number[] = {
    /* number.c */
    { "+", (ScmFuncType)scm_p_add, SCM_REDUCTION_OPERATOR },
    { "*", (ScmFuncType)scm_p_multiply, SCM_REDUCTION_OPERATOR },
    { "-", (ScmFuncType)scm_p_subtract, SCM_REDUCTION_OPERATOR },
    { "/", (ScmFuncType)scm_p_divide, SCM_REDUCTION_OPERATOR },
    { "number?", (ScmFuncType)scm_p_numberp, SCM_PROCEDURE_FIXED_1 },
    { "integer?", (ScmFuncType)scm_p_integerp, SCM_PROCEDURE_FIXED_1 },
    { "=", (ScmFuncType)scm_p_equal, SCM_REDUCTION_OPERATOR },
    { "<", (ScmFuncType)scm_p_less, SCM_REDUCTION_OPERATOR },
    { "<=", (ScmFuncType)scm_p_less_equal, SCM_REDUCTION_OPERATOR },
    { ">", (ScmFuncType)scm_p_greater, SCM_REDUCTION_OPERATOR },
    { ">=", (ScmFuncType)scm_p_greater_equal, SCM_REDUCTION_OPERATOR },
    { "zero?", (ScmFuncType)scm_p_zerop, SCM_PROCEDURE_FIXED_1 },
    { "positive?", (ScmFuncType)scm_p_positivep, SCM_PROCEDURE_FIXED_1 },
    { "negative?", (ScmFuncType)scm_p_negativep, SCM_PROCEDURE_FIXED_1 },
    { "odd?", (ScmFuncType)scm_p_oddp, SCM_PROCEDURE_FIXED_1 },
    { "even?", (ScmFuncType)scm_p_evenp, SCM_PROCEDURE_FIXED_1 },
    { "max", (ScmFuncType)scm_p_max, SCM_REDUCTION_OPERATOR },
    { "min", (ScmFuncType)scm_p_min, SCM_REDUCTION_OPERATOR },
    { "abs", (ScmFuncType)scm_p_abs, SCM_PROCEDURE_FIXED_1 },
    { "quotient", (ScmFuncType)scm_p_quotient, SCM_PROCEDURE_FIXED_2 },
    { "modulo", (ScmFuncType)scm_p_modulo, SCM_PROCEDURE_FIXED_2 },
    { "remainder", (ScmFuncType)scm_p_remainder, SCM_PROCEDURE_FIXED_2 },

    { NULL, NULL, SCM_FUNCTYPE_INVALID }
};
