/*===========================================================================
 *  Filename : functable-r5rs-string-procedure.c
 *  About    : Built-in function table
 *             This file is auto-generated by build_func_table.rb
 *
 *  Copyright (C) 2005-2006 Kazuki Ohta <mover AT hct.zaq.ne.jp>
 *  Copyright (c) 2007-2008 SigScheme Project <uim-en AT googlegroups.com>
 *
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of authors nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
===========================================================================*/

#include <stddef.h>

#include "sigscheme.h"


static const struct scm_func_registration_info scm_functable_r5rs_string_procedure[] = {
    /* string-procedure.c */
    { "make-string", (ScmFuncType)scm_p_make_string, SCM_PROCEDURE_VARIADIC_1 },
    { "string", (ScmFuncType)scm_p_string, SCM_PROCEDURE_VARIADIC_0 },
    { "string-ref", (ScmFuncType)scm_p_string_ref, SCM_PROCEDURE_FIXED_2 },
    { "string-set!", (ScmFuncType)scm_p_string_setx, SCM_PROCEDURE_FIXED_3 },
    { "string-ci=?", (ScmFuncType)scm_p_string_ci_equalp, SCM_PROCEDURE_FIXED_2 },
    { "string>?", (ScmFuncType)scm_p_string_greaterp, SCM_PROCEDURE_FIXED_2 },
    { "string<?", (ScmFuncType)scm_p_string_lessp, SCM_PROCEDURE_FIXED_2 },
    { "string>=?", (ScmFuncType)scm_p_string_greater_equalp, SCM_PROCEDURE_FIXED_2 },
    { "string<=?", (ScmFuncType)scm_p_string_less_equalp, SCM_PROCEDURE_FIXED_2 },
    { "string-ci>?", (ScmFuncType)scm_p_string_ci_greaterp, SCM_PROCEDURE_FIXED_2 },
    { "string-ci<?", (ScmFuncType)scm_p_string_ci_lessp, SCM_PROCEDURE_FIXED_2 },
    { "string-ci>=?", (ScmFuncType)scm_p_string_ci_greater_equalp, SCM_PROCEDURE_FIXED_2 },
    { "string-ci<=?", (ScmFuncType)scm_p_string_ci_less_equalp, SCM_PROCEDURE_FIXED_2 },
    { "substring", (ScmFuncType)scm_p_substring, SCM_PROCEDURE_FIXED_3 },
    { "string->list", (ScmFuncType)scm_p_string2list, SCM_PROCEDURE_FIXED_1 },
    { "list->string", (ScmFuncType)scm_p_list2string, SCM_PROCEDURE_FIXED_1 },
    { "string-fill!", (ScmFuncType)scm_p_string_fillx, SCM_PROCEDURE_FIXED_2 },
    { "%%string-mutable?", (ScmFuncType)scm_p_string_mutablep, SCM_PROCEDURE_FIXED_1 },
    { "%%string-reconstruct!", (ScmFuncType)scm_p_string_reconstructx, SCM_PROCEDURE_FIXED_1 },

    { NULL, NULL, SCM_FUNCTYPE_INVALID }
};
