/*===========================================================================
 *  Filename : functable-sscm-ext.c
 *  About    : Built-in function table
 *             This file is auto-generated by build_func_table.rb
 *
 *  Copyright (C) 2005-2006 Kazuki Ohta <mover AT hct.zaq.ne.jp>
 *  Copyright (c) 2007-2008 SigScheme Project <uim-en AT googlegroups.com>
 *
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of authors nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
===========================================================================*/

#include <stddef.h>

#include "sigscheme.h"


static const struct scm_func_registration_info scm_functable_sscm_ext[] = {
    /* module-sscm-ext.c */
    { "symbol-bound?", (ScmFuncType)scm_p_symbol_boundp, SCM_PROCEDURE_VARIADIC_1 },
    { "sscm-version", (ScmFuncType)scm_p_sscm_version, SCM_PROCEDURE_FIXED_0 },
    { "%%current-environment", (ScmFuncType)scm_p_current_environment, SCM_PROCEDURE_FIXED_TAILREC_0 },
    { "%%current-char-codec", (ScmFuncType)scm_p_current_char_codec, SCM_PROCEDURE_FIXED_0 },
    { "%%set-current-char-codec!", (ScmFuncType)scm_p_set_current_char_codecx, SCM_PROCEDURE_FIXED_1 },
    { "%%prealloc-heaps", (ScmFuncType)scm_p_prealloc_heaps, SCM_PROCEDURE_FIXED_1 },
    { "%%pair-mutable?", (ScmFuncType)scm_p_pair_mutablep, SCM_PROCEDURE_FIXED_1 },
    { "fixnum-width", (ScmFuncType)scm_p_fixnum_width, SCM_PROCEDURE_FIXED_0 },
    { "least-fixnum", (ScmFuncType)scm_p_least_fixnum, SCM_PROCEDURE_FIXED_0 },
    { "greatest-fixnum", (ScmFuncType)scm_p_greatest_fixnum, SCM_PROCEDURE_FIXED_0 },
    { "require", (ScmFuncType)scm_p_require, SCM_PROCEDURE_FIXED_1 },
    { "provide", (ScmFuncType)scm_p_provide, SCM_PROCEDURE_FIXED_1 },
    { "provided?", (ScmFuncType)scm_p_providedp, SCM_PROCEDURE_FIXED_1 },
    { "length*", (ScmFuncType)scm_p_lengthstar, SCM_PROCEDURE_FIXED_1 },
    { "exit", (ScmFuncType)scm_p_exit, SCM_PROCEDURE_VARIADIC_0 },
    { "let-optionals*", (ScmFuncType)scm_s_let_optionalsstar, SCM_SYNTAX_VARIADIC_TAILREC_2 },

    { NULL, NULL, SCM_FUNCTYPE_INVALID }
};
